Index: apps/app_voicemail.c
===================================================================
--- apps/app_voicemail.c	(revision 82566)
+++ apps/app_voicemail.c	(working copy)
@@ -572,6 +572,7 @@
 static int maxgreet;
 static int skipms;
 static int maxlogins;
+static int ignoreheard=0;	/* Leave heard Messages in INBOX */
 
 /*! Poll mailboxes for changes since there is something external to
  *  app_voicemail that may change them. */
@@ -4739,7 +4740,7 @@
 	res = 0;
 
 	if (!res) {
-		vms->heard[vms->curmsg] = 1;
+		if( !ignoreheard ) vms->heard[vms->curmsg] = 1;
 		res = wait_file(chan, vms, vms->fn);
 	}
 	DISPOSE(vms->curdir, vms->curmsg);
@@ -4838,7 +4839,7 @@
 
 	if (!res) {
 		make_file(vms->fn, sizeof(vms->fn), vms->curdir, vms->curmsg);
-		vms->heard[vms->curmsg] = 1;
+		if( !ignoreheard ) vms->heard[vms->curmsg] = 1;
 		res = wait_file(chan, vms, vms->fn);
 	}
 	DISPOSE(vms->curdir, vms->curmsg);
@@ -8299,6 +8300,11 @@
 		}
 		ast_set2_flag((&globalflags), ast_true(val), VM_SAYDURATION);	
 
+		if ((val = ast_variable_retrieve(cfg, "general", "ignoreheard"))) {
+			ast_debug(1,"Ignore Heard Status enabled globally '%s'\n",val);
+			ignoreheard = ast_true(val);
+		}
+
 		saydurationminfo = 2;
 		if ((val = ast_variable_retrieve(cfg, "general", "saydurationm"))) {
 			if (sscanf(val, "%d", &x) == 1) {
@@ -8892,7 +8898,7 @@
 
 	if (!res) {
 		make_file(vms->fn, sizeof(vms->fn), vms->curdir, msg);
-		vms->heard[msg] = 1;
+		if( !ignoreheard ) vms->heard[msg] = 1;
 		res = wait_file(chan, vms, vms->fn);
 	}
 #endif
Index: configs/voicemail.conf.sample
===================================================================
--- configs/voicemail.conf.sample	(revision 82566)
+++ configs/voicemail.conf.sample	(working copy)
@@ -51,6 +51,11 @@
 ; Max number of failed login attempts
 maxlogins=3
 ;
+; Ignore heard message status (Comedian Mail normally moves 'heard'
+; messages to the 'Old' folder automagically. Turning this option on
+; prevents that behaviour). Default off
+;ignoreheard=no
+;
 ; User context is where entries from users.conf are registered.  The
 ; default value is 'default'
 ;
